local addon, ns = ...

-- Got Class?
--if not ( select(2,UnitClass("player")) == "SHAMAN" ) then return end
-- Yay!

local KokoTotems = KokoTotems --LibStub:GetAddon("KokoTotems")
local libKoko = LibStub:GetLibrary('LibKoko-2.0')
local libTotems = LibStub:GetLibrary('KokoTotems-1.2')
local GTBLib, GTBTotem

if not KokoTotems then return end
if not libTotems then return end

ns.InitSettings = function()
  if not KokoTotemsTimers_DB then
      KokoTotemsTimers_DB = {
         ['enabled'] = true,
         ['anchor'] = true,
         ['texture'] = 'KTT Default',
         ['texpath'] = 'Interface\\AddOns\\KokoTotems_Timers\\Textures\\default',
         ['font'] = 'Friz Quadrata TT',
         ['fontpath'] = 'Fonts\\FRIZQT__.TTF',
         ['font_size'] = 12,
         ['timer'] = {
            ['x'] = 240,
            ['y'] = 500,
            ['scale'] = 1,
            ['width'] =180,
            ['icon'] = 'LEFT',
            ['growth'] = 'DOWN',
         },
      }
   end
end

ns.InitTotemBars = function()
      -- settings
   local db = KokoTotemsTimers_DB
   
   -- initialize totem timer group and load GTB
	if not GTBLib then
		GTBLib = LibStub:GetLibrary("GTB-1.0")
	end
		
	if not GTBTotem then
		GTBTotem = GTBLib:RegisterGroup("Totem Timers",'');

      GTBTotem:RegisterOnMove(function(parent, x, y) 
      	ns.SetBarInfo('timer', 'x', x)
         ns.SetBarInfo('timer', 'y', y)
      end)
	end
   
   -- build the bars
   GTBTotem:SetDisplayGroup("Totem Timers")
   GTBTotem:SetPoint("TOPLEFT", "UIParent", "BOTTOMLEFT", db['timer'].x, db['timer'].y);
   GTBTotem:SetMaxBars(libTotems:GetMaxTotems());
   GTBTotem:SetBarGrowth(db['timer'].growth);
   GTBTotem:SetIconPosition(db['timer'].icon);
   GTBTotem:SetScale(db['timer'].scale)
   GTBTotem:SetWidth(db['timer'].width)

   -- set texture/font/anchors
   ns.SetTexture()
   ns.SetFont()
   ns.SetAnchor(ns.GetGlobalInfo('anchor'))
   
   -- release
   ns.GTBTotem = GTBTotem
end

ns.SetTexture = function()
   GTBTotem:SetTexture(ns.GetGlobalInfo('texpath'))
end

ns.SetFont = function()
   local path = ns.GetGlobalInfo('fontpath')
   local size = ns.GetGlobalInfo('font_size')

   GTBTotem:SetFont(path, size)
end

ns.SetAnchor = function(val)
   GTBTotem:SetAnchorVisible(val);
end

ns.InitAll = function()
   ns.InitSettings()
   if KokoTotemsTimers_DB.enabled then
      ns.InitTotemBars()
      
      -- register callback events
      libTotems.RegisterCallback(ns, "TOTEMS_PTU_NEW")

      libTotems.RegisterCallback(ns, "TOTEMS_PTU_DESTROY")
   else
      -- hide bars
      if GTBTotem then
			GTBTotem:SetAnchorVisible(false);
			GTBTotem:UnregisterAllBars(i);
		end
      -- unregister callback events
      libTotems.UnregisterCallback(ns, "TOTEMS_PTU_NEW")
      libTotems.UnregisterCallback(ns, "TOTEMS_PTU_DESTROY")
   end
end

function ns:TOTEMS_PTU_NEW(event, slot, name, est_dur, duration, icon, spellid)
   if (duration > 0 ) then
		-- Assume totem was dropped
		GTBTotem:RegisterBar(slot, name, est_dur, duration, icon);
   end
end

function ns:TOTEMS_PTU_DESTROY(event, slot, name, icon, spellid)
   GTBTotem:UnregisterBar(slot);
end
-- libTotems
libTotems:RegisterStartup(ns.InitAll)
libKoko:RegisterAddonPlugIn("KokoTotems", 'Timers', ns.menu)




